﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Diagnostics;
using System.Web.UI.WebControls.WebParts;
using System.ComponentModel;

using Microsoft.Office.Server.Search.WebControls;
using Microsoft.Office.Server.Search.Administration;
using Microsoft.Office.Server.Search.Query;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebPartPages;

namespace SortedResultsPart
{
    class MSDNSample : CoreResultsWebPart
    {

        public MSDNSample()
        {
            //default constructor; needed for serialization support
        }

        protected override void CreateChildControls()
        {
            base.CreateChildControls();

            //add any additional controls needed for your UI here
        }

        protected override void CreateDataSource()
        {
            //base.CreateDataSource();
            this.DataSource = new MyCoreResultsDataSource(this);
        }


        public class MyCoreResultsDataSource : CoreResultsDatasource
        {
            public MyCoreResultsDataSource(CoreResultsWebPart ParentWebpart)
                : base(ParentWebpart)
            {
                //if I needed to reference the properties or methods of the web part
                //then the ParentWebPart parameter is how I would do that

                //create the View that will be used with this datasource
                this.View = new MyCoreResultsDataSourceView(this, "MyCoreResults");
            }
        }


        public class MyCoreResultsDataSourceView : CoreResultsDatasourceView    
        {

            public MyCoreResultsDataSourceView(SearchResultsBaseDatasource DataSourceOwner, string ViewName)
                            : base(DataSourceOwner, ViewName)
            {
                //make sure we have a value for the datasource
                if (DataSourceOwner == null)
                {
                    throw new ArgumentNullException("DataSourceOwner");
                }

                //get a typed reference to our datasource
                MyCoreResultsDataSource ds = this.DataSourceOwner as MyCoreResultsDataSource;

                //configure the query manager for this View
                this.QueryManager = SharedQueryManager.GetInstance(ds.ParentWebpart.Page).QueryManager;
            }


            public override void AddSortOrder(SharePointSearchRuntime runtime)
            {
                //make sure our runtime has been properly instantiated
                if (runtime.KeywordQueryObject == null)
                {
                    return;
                }

                //remove any other sorted fields we might have had
                runtime.KeywordQueryObject.SortList.Clear();

                //get the datasource so we can get to the web part and retrieve the sort fields the user selected
                SearchResultsPart wp = this.DataSourceOwner.ParentWebpart as SearchResultsPart;
                string sortField = wp.SortFields;

                //no sort fields provided so use the default sort order
                base.AddSortOrder(runtime);
            }
        }
    }
}
